﻿using System;
using System.Web.UI;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.WebForms;

namespace WebFormsDemo
{
    public partial class WebForm1 : System.Web.UI.Page, ICallbackEventHandler
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                CargaInicial();
            }
        }

        private void CargaInicial()
        {
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            ShapeFileFeatureLayer layer = new ShapeFileFeatureLayer(MapPath(@"App_Data\states.shp"));
            layer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            layer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay overlay = new LayerOverlay("worldOverlay");
            overlay.ClientCache.Duration = new TimeSpan(1);
            overlay.Layers.Add(layer);
            Map1.CustomOverlays.Add(overlay);


            layer.Open();
            Map1.CurrentExtent = layer.GetBoundingBox();
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            TextBox1.Text = DateTime.Now.ToString();
        }

        protected void Button2_Click(object sender, EventArgs e)
        {
            ShapeFileFeatureLayer layer = new ShapeFileFeatureLayer(MapPath(@"App_Data\states.shp"));
            layer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Grass1;
            layer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            (Map1.CustomOverlays[0] as LayerOverlay).Layers.Clear();
            (Map1.CustomOverlays[0] as LayerOverlay).Layers.Add(layer);
            UpdatePanelMapa.Update();
        }

        public string GetCallbackResult()
        {
            return "sent back message if need";
        }

        public void RaiseCallbackEvent(string eventArgument)
        {
            ShapeFileFeatureLayer layer = new ShapeFileFeatureLayer(MapPath(@"App_Data\states.shp"));
            layer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Grass1;
            layer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            (Map1.CustomOverlays[0] as LayerOverlay).Layers.Clear();
            (Map1.CustomOverlays[0] as LayerOverlay).Layers.Add(layer);
        }

    }
}